/*****************************************************************************
* Copyright (c) Bridgetek Pte Ltd.
* Software License Agreement
*
* This code is provided as an example only and is not guaranteed by Bridgetek. 
* BRIDGETEK accept no responsibility for any issues resulting from its use. 
* The developer of the final application incorporating any parts of this 
* sample project is responsible for ensuring its safe and correct operation 
* and for any consequences resulting from its use.
*****************************************************************************/
/**
* @file  App_Gradient.c/.ino
* @brief Sample application to demonstrate EVE primitives and widgets.
Versoin 5.0 - April/17/2017 - Restructure source code
Version 4.0 - July/01/2015 - Added FT81x support
version 3.1 - Jun/13/2014 - Added CMD_CSKETCH for FT801 platform. 
Version 3.0 - Support for FT801 platform.
Version 2.0 - Support for FT800 emulator platform.
Version 1.0 - Final version based on the requirements.
Version 0.1 - initial draft of the release notes
*/

#include "..\Platform.h"
#include "..\App_Common.h"

/* Global used for Hal Context */
Gpu_Hal_Context_t host,*phost;


void Gradient(Gpu_Hal_Context_t *phost)
{
  uint32_t Read_xy = 0,
              tracker;
  uint16_t x1,x2,y1,y2,
              Read_x = 0,Read_y = 0,
  	      
	      tx = 48,ty = 20,tval;
  uint32_t val1=48568,  val2=32765;
  uint8_t		
             Read_Tag  = 0,
	     drag,buff[512];
  int32_t TPsize;

  x1 = 50;y1 = 50;

  TPsize = DispWidth*5/100;

  x2 = DispWidth-130;
  y2 = DispHeight-60;
  drag = 0;
  // compute the background gradient effect
  for(tval=0;tval<(DispHeight/2);tval++)	
  {
    buff[DispHeight-1-tval] = buff[tval] = (tval*0.9);		
  }
  Gpu_Hal_WrMem(phost,4096L,buff,DispHeight);
  
  // Set the bitmap properties for the background
  App_Set_DlBuffer_Index(0);
  App_WrDl_Buffer(phost,CLEAR(1,1,1));
  App_WrDl_Buffer(phost,COLOR_A(255));
  App_WrDl_Buffer(phost,COLOR_RGB(255,255,255));	
  App_WrDl_Buffer(phost,BITMAP_HANDLE(2));	
  App_WrDl_Buffer(phost,BITMAP_SOURCE(4096L));	
  App_WrDl_Buffer(phost,BITMAP_LAYOUT(L8,1,DispHeight));	
  App_WrDl_Buffer(phost,BITMAP_SIZE(NEAREST, REPEAT, BORDER, 512, DispHeight));
  Gpu_CoCmd_Track(phost,(DispWidth-38),40,8,DispHeight-65,3);	
  Gpu_CoCmd_Track(phost,(DispWidth-15),40,8,DispHeight-65,4);	
  App_WrDl_Buffer(phost,DISPLAY());
  App_Flush_DL_Buffer(phost);
  Gpu_Hal_Wr8(phost,REG_DLSWAP,DLSWAP_FRAME);
  Gpu_Hal_WaitCmdfifo_empty(phost);  
  do
  {
    /* Read the Touch\drag*/
    Read_xy = Gpu_Hal_Rd32(phost,REG_TOUCH_SCREEN_XY); 
    Read_Tag = Gpu_Hal_Rd8(phost,REG_TOUCH_TAG);
    // pick the x& y cordinates of the points  
    Read_y = Read_xy & 0xffff;
    Read_x = (Read_xy >> 16) & 0xffff;
    if(Read_xy == 0x80008000)  drag = 0;
    else if(Read_Tag==1 || Read_Tag==2)drag = Read_Tag; 
    /* compute the coordintes of two points x&y*/
    if(drag == 1)
    {
	if(Read_x>=(DispWidth-60))0; else	x1 = Read_x; 
	if(Read_y>=(DispHeight-20))0; else	y1 = Read_y;
    }
    if(drag == 2)
    {
	if(Read_x>=(DispWidth-60))0; else	x2 = Read_x; 
	if(Read_y>=(DispHeight-20))0; else	y2 = Read_y;
    }
    tracker = Gpu_Hal_Rd32(phost,REG_TRACKER);	
    if((tracker&0xff) > 2)
    {
      if((tracker&0xff)==3)
      {
	val1 = (tracker>>16);		
      }
      else if((tracker&0xff)==4)
      {
	val2 = (tracker>>16);		
      }
    }
// start the new displaylist
    Gpu_CoCmd_Dlstart(phost); 
    App_WrCoCmd_Buffer(phost,CLEAR_COLOR_RGB(55,55,55));
    App_WrCoCmd_Buffer(phost,CLEAR(1,1,1) );
    App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS));
    App_WrCoCmd_Buffer(phost,VERTEX2II(0,0,2,0));
    Gpu_CoCmd_FgColor(phost,0xffffff);
  
    App_WrCoCmd_Buffer(phost,TAG_MASK(1));	
  
    Gpu_CoCmd_BgColor(phost,val2*255);	
    App_WrCoCmd_Buffer(phost,TAG(4));
    Gpu_CoCmd_Slider(phost,(DispWidth-40),40,18,(DispHeight-65),0,val2,65535);	
  
    Gpu_CoCmd_BgColor(phost,val1*255);
    App_WrCoCmd_Buffer(phost,TAG(3));
    Gpu_CoCmd_Slider(phost,(DispWidth-80),40,18,(DispHeight-65),0,val1,65535);	
    App_WrCoCmd_Buffer(phost,TAG_MASK(0));
  
  
    App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));

    Gpu_CoCmd_Text(phost,DispWidth-80,10,26,0,"C1");
    Gpu_CoCmd_Text(phost,DispWidth-40,10,26,0,"C2");
    App_WrCoCmd_Buffer(phost,SCISSOR_XY(10,10));
    App_WrCoCmd_Buffer(phost,SCISSOR_SIZE(DispWidth-100,DispHeight-30));
    App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
    Gpu_CoCmd_Gradient(phost,x1,y1,val1*255,x2,y2,val2*255);
  		
    App_WrCoCmd_Buffer(phost,COLOR_RGB(0,0,0));
    // Place a dot for drag the color
    App_WrCoCmd_Buffer(phost,BEGIN(FTPOINTS));
    App_WrCoCmd_Buffer(phost,COLOR_MASK(0,0,0,0));
    App_WrCoCmd_Buffer(phost,POINT_SIZE(TPsize*16));
    App_WrCoCmd_Buffer(phost,TAG_MASK(1));
    App_WrCoCmd_Buffer(phost,TAG(1));
    App_WrCoCmd_Buffer(phost,VERTEX2F(x1*16,y1*16));
    App_WrCoCmd_Buffer(phost,TAG(2));
    App_WrCoCmd_Buffer(phost,VERTEX2F(x2*16,y2*16));
    App_WrCoCmd_Buffer(phost,TAG_MASK(0));
  
    /* calculation of touch point size */

    App_WrCoCmd_Buffer(phost,COLOR_MASK(1,1,1,1));
    App_WrCoCmd_Buffer(phost,POINT_SIZE(TPsize*16));
    App_WrCoCmd_Buffer(phost,BEGIN(FTPOINTS));
    App_WrCoCmd_Buffer(phost,VERTEX2F(x1*16,y1*16));
    App_WrCoCmd_Buffer(phost,VERTEX2F(x2*16,y2*16));
    App_WrCoCmd_Buffer(phost,COLOR_MASK(1,1,1,1));
    App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
    App_WrCoCmd_Buffer(phost,BEGIN(LINES));
    App_WrCoCmd_Buffer(phost,VERTEX2F((x1-TPsize)*16,(y1)*16));
    App_WrCoCmd_Buffer(phost,VERTEX2F((x1+TPsize)*16,(y1)*16));
    App_WrCoCmd_Buffer(phost,VERTEX2F((x1)*16,(y1-TPsize)*16));
    App_WrCoCmd_Buffer(phost,VERTEX2F((x1)*16,(y1+TPsize)*16));
    App_WrCoCmd_Buffer(phost,VERTEX2F((x2-TPsize)*16,(y2)*16));
    App_WrCoCmd_Buffer(phost,VERTEX2F((x2+TPsize)*16,(y2)*16));
    App_WrCoCmd_Buffer(phost,VERTEX2F((x2)*16,(y2-TPsize)*16));
    App_WrCoCmd_Buffer(phost,VERTEX2F((x2)*16,(y2+TPsize)*16));
    App_WrCoCmd_Buffer(phost,END());
    App_WrCoCmd_Buffer(phost,DISPLAY());
    Gpu_CoCmd_Swap(phost);
    App_Flush_Co_Buffer(phost);
    Gpu_Hal_WaitCmdfifo_empty(phost);	
  }while(1);
}


#if defined(ARDUINO_PLATFORM)
const PROGMEM char * const info[] =
#else
char *info[] =
#endif
{ "EVE Gradient Application",
	"APP to demonstrate interactive Gradient,",
	"using String, Gradient",
	"& Slider."
};

//#if defined (MSVC_PLATFORM) || defined (FT900_PLATFORM) || defined (FT93X_PLATFORM)
///* Main entry point */
//int32_t main(int32_t argc,char8_t *argv[])
//#endif
//#if defined(ARDUINO_PLATFORM)||defined(MSVC_FT800EMU)
//void setup()
//#endif
void main()
{
    phost = &host;
	/* Init HW Hal */
    App_Common_Init(phost);
    /* Show Logo, do calibration and display welcome screeen */
    App_Common_Start(phost,info);
    /* Our main application */
    Gradient(phost);
    /* Close all the opened handles */
    App_Common_Close(phost);
	#if defined (MSVC_PLATFORM) || defined (FT900_PLATFORM) || defined (FT93X_PLATFORM)
    return 0;
    #endif
}


void loop()
{
}
/* Nothing beyond this */


