/*****************************************************************************
* Copyright (c) Bridgetek Pte Ltd.
* Software License Agreement
*
* This code is provided as an example only and is not guaranteed by Bridgetek. 
* BRIDGETEK accept no responsibility for any issues resulting from its use. 
* The developer of the final application incorporating any parts of this 
* sample project is responsible for ensuring its safe and correct operation 
* and for any consequences resulting from its use.
*****************************************************************************/
/**
* @file  App_Imageviewer
* @brief Sample application to demonstrate EVE primitives and widgets.
Versoin 5.0 - April/17/2017 - Restructure source code
*/



#include "..\Platform.h"  //RJA  Need to make P2 specific version of this

#include <dirent.h>
#include <sys/stat.h>





typedef struct 
{
	  char name[20];
	  uint32_t file_size;
}Image;
Image Image_prop[20];


static uint16_t cts=0;
FILE *pfile;
static uint32_t filesize;
          
static uchar8_t istouch()
{
  return !(Gpu_Hal_Rd16(phost,REG_TOUCH_RAW_XY) & 0x8000);
}

uint8_t isHighResolution(char *fn){
	uint8_t fileLength = strlen(fn);
	if(fileLength>5 && fn[fileLength-5]=='H' && fn[fileLength-4]=='.' && (fn[fileLength-3]=='j' || fn[fileLength-3]=='J') && (fn[fileLength-2]=='p' || fn[fileLength-2]=='P') && (fn[fileLength-1]=='g' || fn[fileLength-1]=='G'))
		return 1;
	else
		return 0;
}

#define MAX_FILES_TO_RETRIEVE 20

uint16_t List_Out_files()
{ 	
	uint16_t nooffiles=0;

#if defined(MSVC_PLATFORM)|| defined(MSVC_FT800EMU)
    char *path = "..\\..\\Test";
	struct _finddata_t Files;
	long file_spec;	
	if(!_chdir(path))
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA)
		file_spec = _findfirst("*.jpg*", &Files); 
#elif defined(DISPLAY_RESOLUTION_WVGA)
		file_spec = _findfirst("*H.jpg*", &Files); 
#endif
	else 
		return nooffiles;
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA)
	if(!isHighResolution(Files.name)){
		strcpy_P(Image_prop[nooffiles].name,Files.name);
		Image_prop[nooffiles].file_size = (Files.size+3)&~3;
		nooffiles++;
	}
#elif defined(DISPLAY_RESOLUTION_WVGA)
	strcpy_P(Image_prop[nooffiles].name,Files.name);
	Image_prop[nooffiles].file_size = (Files.size+3)&~3;
	nooffiles++;
#endif


	while(_findnext(file_spec,&Files)==0)
	{
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA)
	if(!isHighResolution(Files.name)){
		strcpy_P(Image_prop[nooffiles].name,Files.name);
		Image_prop[nooffiles].file_size = (Files.size+3)&~3;
		nooffiles++;
	}
#elif defined(DISPLAY_RESOLUTION_WVGA)
		strcpy_P(Image_prop[nooffiles].name,Files.name);
		Image_prop[nooffiles].file_size = (Files.size+3)&~3;
		nooffiles++;
#endif
	}
	return nooffiles;
#endif


#if defined(FT9XX_PLATFORM)
	//FRESULT res;
	DIR dir;
	FILINFO fno;
	uint8_t i=1, fileLength;
	char *fn;

	res = f_opendir(&dir, "");

	if(res == FR_OK){
		//i = strlen(".");
		for(;;){
			res = f_readdir(&dir, &fno);
			if(res != FR_OK || fno.fname[0] == 0) break;
			if(fno.fname[0] == '.') continue;
			fn = fno.fname;
			if(fno.fattrib & AM_DIR){
			}
			else{
				fileLength = strlen(fn);
#if defined(DISPLAY_RESOLUTION_WVGA)
				if(fileLength>5 && fn[fileLength-5]=='H' && fn[fileLength-4]=='.' && (fn[fileLength-3]=='j' || fn[fileLength-3]=='J') && (fn[fileLength-2]=='p' || fn[fileLength-2]=='P') && (fn[fileLength-1]=='g' || fn[fileLength-1]=='G')){
#else
					if(fileLength>5 && fn[fileLength-5]!='H' && fn[fileLength-4]=='.' && (fn[fileLength-3]=='j' || fn[fileLength-3]=='J') && (fn[fileLength-2]=='p' || fn[fileLength-2]=='P') && (fn[fileLength-1]=='g' || fn[fileLength-1]=='G')){
#endif
					strcpy(Image_prop[nooffiles].name,fn);
					//Image_prop[nooffiles].file_size = (fno.fsize+3)&~3;
					Image_prop[nooffiles].file_size = fno.fsize;
					printf("Num:%d , Name:%s , Size:%d\n",nooffiles, Image_prop[nooffiles].name, Image_prop[nooffiles].file_size);
					nooffiles++;
					if(nooffiles>=MAX_FILES_TO_RETRIEVE)
						break;
				}
			}
		}
	}
	else
	{	printf("\n fail");}
	//f_closedir(&dir);
	return nooffiles;
#endif

    //RJA try to do the same for P2
    DIR* d;
    struct dirent* ent;
    struct stat sbuf;
    int r;
#if defined(USE_SD)
    mount("/files", _vfs_open_sdcard());
    chdir("/files");
#elif defined(USE_HOST)
    mount("/files", _vfs_open_host());
    chdir("/files");
#else
    #warning no file system specified, I hope you are compiling for PC
#endif
        d = opendir(".");
    if (!d) {
        printf("Unable to open directory\n");
        return 1;
    }
    printf("Files in current directory:\n");
    for (;;) {
        ent = readdir(d);
        if (!ent) break;
        r = stat(ent->d_name, &sbuf);
        if (r) {
            //printf("??? error in stat of %s\n", ent->d_name);
        }
        else if ((sbuf.st_mode & S_IFMT) == S_IFDIR) {
            //printf("%8s %s\n", "<dir>", ent->d_name);
        }
        else 
        {
            //printf("%8u %s\n", sbuf.st_size, ent->d_name);

            //RJA trying to adapt FT9XX_PLATFORM code
            char *fn = ent->d_name;
            {
                int fileLength = strlen(fn);
#if defined(DISPLAY_RESOLUTION_WVGA)
                if (fileLength > 5 && fn[fileLength - 5] == 'H' && fn[fileLength - 4] == '.' && (fn[fileLength - 3] == 'j' || fn[fileLength - 3] == 'J') && (fn[fileLength - 2] == 'p' || fn[fileLength - 2] == 'P') && (fn[fileLength - 1] == 'g' || fn[fileLength - 1] == 'G')) {
#else
                if (fileLength > 5 && fn[fileLength - 5] != 'H' && fn[fileLength - 4] == '.' && (fn[fileLength - 3] == 'j' || fn[fileLength - 3] == 'J') && (fn[fileLength - 2] == 'p' || fn[fileLength - 2] == 'P') && (fn[fileLength - 1] == 'g' || fn[fileLength - 1] == 'G')) {
#endif
                    strcpy(Image_prop[nooffiles].name, fn);
                    //Image_prop[nooffiles].file_size = (fno.fsize+3)&~3;
                    Image_prop[nooffiles].file_size = sbuf.st_size;
                    printf("Num:%d , Name:%s , Size:%d\n", nooffiles, Image_prop[nooffiles].name, Image_prop[nooffiles].file_size);
                    nooffiles++;
                    if (nooffiles >= MAX_FILES_TO_RETRIEVE)
                        break;
                }
            }
        }
    }
    closedir(d);
    return nooffiles;

}


void Load_Jpeg()
{
	uint8_t imbuff[8192];
	int32_t blocklen;
	int32_t bytesRead;
	while(filesize > 0)
	{
		blocklen = filesize>8192?8192:filesize;
		bytesRead = fread(imbuff,1,blocklen,pfile);							/* copy the data into pbuff and then transfter it to command buffer */

		filesize -= blocklen;
		Gpu_Hal_WrCmdBuf(phost,imbuff,blocklen);				/* copy data continuously into command memory */
	}

	fclose(pfile);												/* close the opened jpg file */
}

static uint16_t nooffiles = 0;
void Loadimage2ram(uint8_t bmphandle)
{

	pfile = fopen(Image_prop[cts].name,"rb");			// read Binary (rb)


	filesize = Image_prop[cts].file_size;
	cts++;
    if(cts>(nooffiles-1)) cts = 0;

	fseek(pfile,0,SEEK_SET);


	
	Gpu_Hal_WrCmd32(phost,CMD_LOADIMAGE);
#if defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
	Gpu_Hal_WrCmd32(phost,(bmphandle ? 131072L : 100));
#elif defined(DISPLAY_RESOLUTION_WVGA)
	Gpu_Hal_WrCmd32(phost,(bmphandle ? 400000L : 300));  //different ram location for bigger bitmap
#endif

	Gpu_Hal_WrCmd32(phost,OPT_NODL); 
	fflush(stdout);
	Load_Jpeg();
}





void Imageviewer()
{
  uint16_t i,xv;
  uint16_t aspect_ratio = 0;
  uint16_t transform = 273L,boot=1, imgWidth=512, imgHeight=308, refGradHeight=64;
  
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
  int32_t  px = ((DispWidth-320)/2)+aspect_ratio,
	      x = ((DispWidth-320)/2)+aspect_ratio,
	      tracker=0,temp_x;
#elif  defined(DISPLAY_RESOLUTION_WVGA)
  int32_t  px = ((DispWidth-512)/2)+aspect_ratio,x = ((DispWidth-512)/2)+aspect_ratio,tracker=0,temp_x;
#else
  int32_t  px = ((DispWidth-512)/2)+aspect_ratio,x = ((DispWidth-512)/2)+aspect_ratio,tracker=0,temp_x;
#endif


  
  uint8_t 
 		r = 1,loaded = 0,Touch_detected=0;

  temp_x = x;
  
  Gpu_Hal_Wr16(phost,REG_VOL_SOUND,100);
  Gpu_Hal_Wr16(phost,REG_SOUND,0x51);
 
	nooffiles = List_Out_files();
	if(nooffiles==0)
	{
		printf("\n Files not found");
		return;
	}	
    printf("%d files found.\n", nooffiles);  //RJA




  Loadimage2ram(r);	
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
  for (i = 0; i < 64; i++)
	Gpu_Hal_Wr8(phost,i,96- (3 * i / 2));
#elif defined(DISPLAY_RESOLUTION_WVGA)
  for (i = 0; i < 180; i++){
	Gpu_Hal_Wr8(phost,i,90-(i / 2));
  }
#endif
  App_Set_CmdBuffer_Index(0);
  Gpu_CoCmd_Dlstart(phost);    
  App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
  App_WrCoCmd_Buffer(phost, BITMAP_HANDLE(r));
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
  App_WrCoCmd_Buffer(phost, BITMAP_SOURCE((r ? 131072L : 100)));
  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(RGB565,320L*2,194));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST,BORDER,BORDER,320,194));
#elif defined(DISPLAY_RESOLUTION_WVGA)
  App_WrCoCmd_Buffer(phost, BITMAP_SOURCE((r ? 400000L : 300)));
  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(RGB565,imgWidth*2,imgHeight));
  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT_H((imgWidth*2)>>10,imgHeight>>9));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST,BORDER,BORDER,imgWidth,imgHeight));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE_H(imgWidth>>9,imgHeight>>9));
#endif
  //reflection gradient
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA)  || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
  App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(2));
  App_WrCoCmd_Buffer(phost,BITMAP_SOURCE(0));
  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(L8, 1, 64));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST, REPEAT, BORDER, DispWidth,64));
#elif defined(DISPLAY_RESOLUTION_WVGA)
  App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(2));
  App_WrCoCmd_Buffer(phost,BITMAP_SOURCE(0));
  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(L8, 1, 180));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST, REPEAT, BORDER, DispWidth,180));
  App_WrCoCmd_Buffer(phost,BITMAP_SIZE_H(DispWidth>>9,0));
#endif
  App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS));
#if defined(DISPLAY_RESOLUTION_WQVGA) || defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
  App_WrCoCmd_Buffer(phost,VERTEX2II(x, (10+aspect_ratio),r, 0));	
#elif defined(DISPLAY_RESOLUTION_WVGA)
  App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r));
  App_WrCoCmd_Buffer(phost,CELL(0));
  App_WrCoCmd_Buffer(phost,VERTEX2F(x*16, (10+aspect_ratio)*16));
#endif
  App_WrCoCmd_Buffer(phost,DISPLAY());
  Gpu_CoCmd_Swap(phost);
  App_Flush_Co_Buffer(phost); 
  Gpu_Hal_WaitCmdfifo_empty(phost);	


  while(1)
  {
    Gpu_CoCmd_Dlstart(phost);  
    App_WrCoCmd_Buffer(phost,CLEAR(1,1,1));
    Gpu_CoCmd_Gradient(phost,0, DispHeight/2, 0x000000, 0, DispHeight, 0x605040);
    App_WrCoCmd_Buffer(phost,COLOR_RGB(255,255,255));
    App_WrCoCmd_Buffer(phost,BEGIN(BITMAPS));
    if (x != temp_x) 
    {
      App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r ^ 1));
      App_WrCoCmd_Buffer(phost,CELL(0));
#if defined(DISPLAY_RESOLUTION_WVGA)
      App_WrCoCmd_Buffer(phost,VERTEX2F(16 * (x-656), 16 *(10+aspect_ratio)));
#elif defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA)  ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
      App_WrCoCmd_Buffer(phost,VERTEX2F(16 * (x-400), 16 *(10+aspect_ratio)));
#endif
    }
    
#if defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA)  ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
    App_WrCoCmd_Buffer(phost,VERTEX2II(x, (10+aspect_ratio),r, 0));	
#elif defined(DISPLAY_RESOLUTION_WVGA)
	App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r));
	App_WrCoCmd_Buffer(phost,VERTEX2F(x*16, (10+aspect_ratio)*16));	
#endif
    App_WrCoCmd_Buffer(phost,SAVE_CONTEXT());
    App_WrCoCmd_Buffer(phost,COLOR_MASK(0,0,0,1));
    App_WrCoCmd_Buffer(phost,BLEND_FUNC(ONE, ZERO));


	#if defined(DISPLAY_RESOLUTION_QVGA) ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
	App_WrCoCmd_Buffer(phost,VERTEX2II(x, 207, 2, 0));
	#elif defined(DISPLAY_RESOLUTION_WQVGA)
    App_WrCoCmd_Buffer(phost,VERTEX2II(0, 212, 2, 0));
	#elif defined(DISPLAY_RESOLUTION_WVGA)
	App_WrCoCmd_Buffer(phost,VERTEX2II(0, 300, 2, 0));
	#endif
    App_WrCoCmd_Buffer(phost,COLOR_MASK(1,1,1,1));
    App_WrCoCmd_Buffer(phost,BLEND_FUNC(DST_ALPHA, ONE_MINUS_DST_ALPHA));

#if defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA)  ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
    Gpu_CoCmd_LoadIdentity(phost);
    Gpu_CoCmd_Translate(phost,(temp_x)*65536L, 65536L*96.5);
    Gpu_CoCmd_Scale(phost,1*65536, 65536*-1);
    Gpu_CoCmd_Translate(phost,-(temp_x)*65536L, 65536L*-96.5);
    Gpu_CoCmd_SetMatrix(phost);
#elif defined(DISPLAY_RESOLUTION_WVGA)
    Gpu_CoCmd_LoadIdentity(phost);
    //Gpu_CoCmd_Translate(phost,(temp_x)*65536L, 65536L*(10+aspect_ratio));
    //Gpu_CoCmd_Scale(phost,1*65536, 65536*-1);
    //Gpu_CoCmd_Translate(phost,-(temp_x)*65536L, 65536L*-(10+aspect_ratio));

    Gpu_CoCmd_Translate(phost,256*65536L, 65536L*150);
    Gpu_CoCmd_Scale(phost,1*65536, 65536*-1);
    Gpu_CoCmd_Translate(phost,-256*65536L, 65536L*-150);
    Gpu_CoCmd_SetMatrix(phost);
#endif
    
    if (x != temp_x)
    {
	App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r ^ 1));
	App_WrCoCmd_Buffer(phost,CELL(0));
#if defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA)  ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
	App_WrCoCmd_Buffer(phost,VERTEX2F(16 * (x-400), 16 * 212));
#elif defined(DISPLAY_RESOLUTION_WVGA)
	App_WrCoCmd_Buffer(phost,VERTEX2F(16 * (x-656), 16 * 365));
#endif
    }
	#if defined(DISPLAY_RESOLUTION_QVGA) ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
	App_WrCoCmd_Buffer(phost,VERTEX2II(x, 207, r, 0));
	#elif defined(DISPLAY_RESOLUTION_WQVGA)
    App_WrCoCmd_Buffer(phost,VERTEX2II(x, 212, r, 0));
	#elif defined(DISPLAY_RESOLUTION_WVGA)
		App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r));
		App_WrCoCmd_Buffer(phost,VERTEX2F(x*16, 365*16));
	#endif
    App_WrCoCmd_Buffer(phost,RESTORE_CONTEXT());
	//printf("px: %d, temp_x: %d, loaded: %d, boot: %d\n",px, temp_x, loaded, boot);
    if(px == temp_x && loaded==0 && boot==0) 
    {  
#if defined(DISPLAY_RESOLUTION_QVGA) || defined(DISPLAY_RESOLUTION_WQVGA)  ||  defined(DISPLAY_RESOLUTION_HVGA_PORTRAIT)
      App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r^1));
      App_WrCoCmd_Buffer(phost,BITMAP_SOURCE(((r^1) ? 131072L : 100)));
      App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(RGB565,320L*2,194));
      App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST,BORDER,BORDER,320,194));
#elif defined(DISPLAY_RESOLUTION_WVGA)
      App_WrCoCmd_Buffer(phost,BITMAP_HANDLE(r^1));
      App_WrCoCmd_Buffer(phost,BITMAP_SOURCE(((r^1) ? 400000L : 300)));
      App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT(RGB565,imgWidth*2,imgHeight));
	  App_WrCoCmd_Buffer(phost,BITMAP_LAYOUT_H((imgWidth*2)>>10,imgHeight>>9));
      App_WrCoCmd_Buffer(phost,BITMAP_SIZE(NEAREST,BORDER,BORDER,imgWidth,imgHeight));
	  App_WrCoCmd_Buffer(phost,BITMAP_SIZE_H(imgWidth>>9,imgHeight>>9));
#endif
      Loadimage2ram(r ^ 1);
      loaded = 1;    
   }

    App_WrCoCmd_Buffer(phost,DISPLAY());
    Gpu_CoCmd_Swap(phost);
    App_Flush_Co_Buffer(phost);
    Gpu_Hal_WaitCmdfifo_empty(phost);
	boot = 0;
  tracker = Gpu_Hal_Rd32(phost,REG_TOUCH_SCREEN_XY);
  if (loaded && x == temp_x && tracker!=0x80008000)
  {
    Gpu_Hal_Wr8(phost,REG_PLAY,1);	// Play the Sound	
    x = DispWidth; 
    r ^= 1;
    loaded = 0;	
  }
  xv = 1 + x / 16;
  px = x;
  x = MAX(temp_x, x - xv);
 }
}



char *info[] =
{  "EVE ImageViewer Application",
    "APP to demonstrate interactive Jpeg decode,",
    "using Blend function, Bitmap flip,", 
    "& Jpeg decode"
}; 


void Gradient(Gpu_Hal_Context_t* phost)
{
    uint32_t Read_xy = 0,
        tracker;
    uint16_t x1, x2, y1, y2,
        Read_x = 0, Read_y = 0,

        tx = 48, ty = 20, tval;
    uint32_t val1 = 48568, val2 = 32765;
    uint8_t
        Read_Tag = 0,
        drag, buff[512];
    int32_t TPsize;

    x1 = 50; y1 = 50;

    TPsize = DispWidth * 5 / 100;

    x2 = DispWidth - 130;
    y2 = DispHeight - 60;
    drag = 0;
    // compute the background gradient effect
    for (tval = 0; tval < (DispHeight / 2); tval++)
    {
        buff[DispHeight - 1 - tval] = buff[tval] = (tval * 0.9);
    }
    Gpu_Hal_WrMem(phost, 4096L, buff, DispHeight);

    // Set the bitmap properties for the background
    App_Set_DlBuffer_Index(0);
    App_WrDl_Buffer(phost, CLEAR(1, 1, 1));
    App_WrDl_Buffer(phost, COLOR_A(255));
    App_WrDl_Buffer(phost, COLOR_RGB(255, 255, 255));
    App_WrDl_Buffer(phost, BITMAP_HANDLE(2));
    App_WrDl_Buffer(phost, BITMAP_SOURCE(4096L));
    App_WrDl_Buffer(phost, BITMAP_LAYOUT(L8, 1, DispHeight));
    App_WrDl_Buffer(phost, BITMAP_SIZE(NEAREST, REPEAT, BORDER, 512, DispHeight));
    Gpu_CoCmd_Track(phost, (DispWidth - 38), 40, 8, DispHeight - 65, 3);
    Gpu_CoCmd_Track(phost, (DispWidth - 15), 40, 8, DispHeight - 65, 4);
    App_WrDl_Buffer(phost, DISPLAY());
    App_Flush_DL_Buffer(phost);
    Gpu_Hal_Wr8(phost, REG_DLSWAP, DLSWAP_FRAME);
    Gpu_Hal_WaitCmdfifo_empty(phost);
    do
    {
        /* Read the Touch\drag*/
        Read_xy = Gpu_Hal_Rd32(phost, REG_TOUCH_SCREEN_XY);
        Read_Tag = Gpu_Hal_Rd8(phost, REG_TOUCH_TAG);
        // pick the x& y cordinates of the points  
        Read_y = Read_xy & 0xffff;
        Read_x = (Read_xy >> 16) & 0xffff;
        if (Read_xy == 0x80008000)  drag = 0;
        else if (Read_Tag == 1 || Read_Tag == 2)drag = Read_Tag;
        /* compute the coordintes of two points x&y*/
        if (drag == 1)
        {
            if (Read_x >= (DispWidth - 60))0; else	x1 = Read_x;
            if (Read_y >= (DispHeight - 20))0; else	y1 = Read_y;
        }
        if (drag == 2)
        {
            if (Read_x >= (DispWidth - 60))0; else	x2 = Read_x;
            if (Read_y >= (DispHeight - 20))0; else	y2 = Read_y;
        }
        tracker = Gpu_Hal_Rd32(phost, REG_TRACKER);
        if ((tracker & 0xff) > 2)
        {
            if ((tracker & 0xff) == 3)
            {
                val1 = (tracker >> 16);
            }
            else if ((tracker & 0xff) == 4)
            {
                val2 = (tracker >> 16);
            }
        }
        // start the new displaylist
        Gpu_CoCmd_Dlstart(phost);
        App_WrCoCmd_Buffer(phost, CLEAR_COLOR_RGB(55, 55, 55));
        App_WrCoCmd_Buffer(phost, CLEAR(1, 1, 1));
        App_WrCoCmd_Buffer(phost, BEGIN(BITMAPS));
        App_WrCoCmd_Buffer(phost, VERTEX2II(0, 0, 2, 0));
        Gpu_CoCmd_FgColor(phost, 0xffffff);

        App_WrCoCmd_Buffer(phost, TAG_MASK(1));

        Gpu_CoCmd_BgColor(phost, val2 * 255);
        App_WrCoCmd_Buffer(phost, TAG(4));
        Gpu_CoCmd_Slider(phost, (DispWidth - 40), 40, 18, (DispHeight - 65), 0, val2, 65535);

        Gpu_CoCmd_BgColor(phost, val1 * 255);
        App_WrCoCmd_Buffer(phost, TAG(3));
        Gpu_CoCmd_Slider(phost, (DispWidth - 80), 40, 18, (DispHeight - 65), 0, val1, 65535);
        App_WrCoCmd_Buffer(phost, TAG_MASK(0));


        App_WrCoCmd_Buffer(phost, COLOR_RGB(255, 255, 255));

        Gpu_CoCmd_Text(phost, DispWidth - 80, 10, 26, 0, "C1");
        Gpu_CoCmd_Text(phost, DispWidth - 40, 10, 26, 0, "C2");
        App_WrCoCmd_Buffer(phost, SCISSOR_XY(10, 10));
        App_WrCoCmd_Buffer(phost, SCISSOR_SIZE(DispWidth - 100, DispHeight - 30));
        App_WrCoCmd_Buffer(phost, CLEAR(1, 1, 1));
        Gpu_CoCmd_Gradient(phost, x1, y1, val1 * 255, x2, y2, val2 * 255);

        App_WrCoCmd_Buffer(phost, COLOR_RGB(0, 0, 0));
        // Place a dot for drag the color
        App_WrCoCmd_Buffer(phost, BEGIN(FTPOINTS));
        App_WrCoCmd_Buffer(phost, COLOR_MASK(0, 0, 0, 0));
        App_WrCoCmd_Buffer(phost, POINT_SIZE(TPsize * 16));
        App_WrCoCmd_Buffer(phost, TAG_MASK(1));
        App_WrCoCmd_Buffer(phost, TAG(1));
        App_WrCoCmd_Buffer(phost, VERTEX2F(x1 * 16, y1 * 16));
        App_WrCoCmd_Buffer(phost, TAG(2));
        App_WrCoCmd_Buffer(phost, VERTEX2F(x2 * 16, y2 * 16));
        App_WrCoCmd_Buffer(phost, TAG_MASK(0));

        /* calculation of touch point size */

        App_WrCoCmd_Buffer(phost, COLOR_MASK(1, 1, 1, 1));
        App_WrCoCmd_Buffer(phost, POINT_SIZE(TPsize * 16));
        App_WrCoCmd_Buffer(phost, BEGIN(FTPOINTS));
        App_WrCoCmd_Buffer(phost, VERTEX2F(x1 * 16, y1 * 16));
        App_WrCoCmd_Buffer(phost, VERTEX2F(x2 * 16, y2 * 16));
        App_WrCoCmd_Buffer(phost, COLOR_MASK(1, 1, 1, 1));
        App_WrCoCmd_Buffer(phost, COLOR_RGB(255, 255, 255));
        App_WrCoCmd_Buffer(phost, BEGIN(LINES));
        App_WrCoCmd_Buffer(phost, VERTEX2F((x1 - TPsize) * 16, (y1) * 16));
        App_WrCoCmd_Buffer(phost, VERTEX2F((x1 + TPsize) * 16, (y1) * 16));
        App_WrCoCmd_Buffer(phost, VERTEX2F((x1) * 16, (y1 - TPsize) * 16));
        App_WrCoCmd_Buffer(phost, VERTEX2F((x1) * 16, (y1 + TPsize) * 16));
        App_WrCoCmd_Buffer(phost, VERTEX2F((x2 - TPsize) * 16, (y2) * 16));
        App_WrCoCmd_Buffer(phost, VERTEX2F((x2 + TPsize) * 16, (y2) * 16));
        App_WrCoCmd_Buffer(phost, VERTEX2F((x2) * 16, (y2 - TPsize) * 16));
        App_WrCoCmd_Buffer(phost, VERTEX2F((x2) * 16, (y2 + TPsize) * 16));
        App_WrCoCmd_Buffer(phost, END());
        App_WrCoCmd_Buffer(phost, DISPLAY());
        Gpu_CoCmd_Swap(phost);
        App_Flush_Co_Buffer(phost);
        Gpu_Hal_WaitCmdfifo_empty(phost);
    } while (1);
}


void main()
{
    printf("RJA trying to get this example working on P2!\n");

    phost = &host;
    /* Init HW Hal */
    App_Common_Init(phost);
    printf("\nInit Complete!\n");



    /* Show Logo, do calibration and display welcome screeen */
    App_Common_Start(phost,info);
    printf("Welcome Screen Complete!\n");

    ////for (;;) {}
    ////Gradient(phost);
    //Gpu_CoCmd_Dlstart(phost);
    //App_WrCoCmd_Buffer(phost, CLEAR_COLOR_RGB(155, 155, 55));
    //Gpu_ClearScreen(phost);
    //Gpu_CoCmd_Dial(phost, 28, 60, 24, 0, 0x0000);
    //char s1[] = "xxx";
    //Gpu_CoCmd_Text(phost, 28, 100, 26, OPT_CENTER, s1);
    //Gpu_CoCmd_Dial(phost, 80, 60, 24, 0, 0x5555);
    //Gpu_CoCmd_Text(phost, 80, 100, 26, OPT_CENTER, s1);
    //Gpu_CoCmd_Dial(phost, 132, 60, 24, 0, 0xaaaa);
    //Gpu_CoCmd_Text(phost, 132, 100, 26, OPT_CENTER, s1);
    //
    //Gpu_CoCmd_Swap(phost);
    //App_Flush_Co_Buffer(phost);
    //for (;;) {}

    /* Main application */
    Imageviewer();    
    printf("Main App Complete!\n");

    /* Close all the opened handles */
    App_Common_Close(phost);

    printf("Done.\n");

	for (;;) {}
}

void loop()
{
}



/* Nothing beyond this */













